/*****************************************************************
  * File Name   : ircdconfig.c
  * Function    : This file will parse and populate the config file
  * History     : create 4th of July 2002. jcorcora
  *****************************************************************/


#include "crazyirc.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>




/**********************************************************************
  * Function name : get_config_info
  * Arguments     : in - file name.
  *                 out - int
  * This function will read a config file and populate a data structure   * with the relavent info from the config file.
  * Returns -1 = error and we exit. or 0 = OK struct populated.
  *********************************************************************/
int
get_config_info     (char *filename)
{
    FILE *fp = NULL;
    int rc = 0,rc2 = 0;
    int pid = 0;
    struct stat buf;
    char filedata[100];
    char *ptr;
    char *value;
    char tag[10];
    int i;
    int config_total = 0;
   
    fprintf(stderr,"Get Config Data.\n"); 
    rc = stat((const char *)filename,&buf);
    
    if (rc != false)
    {
        fprintf(stderr,"Config File Dosen't Exsist.\n");
        rc = -1;
        goto exit_conf_check;
    }
    else
    {
        fp = fopen(filename,"r");
        if (fp == NULL)
        {
            fprintf(stderr,"Error opening file....\n");
            errwin(errno);
            rc = -1;
            goto exit_conf_check;
        }

    }
    rc = 0;

    while(rc == false)
    {
        fgets(filedata,100,fp);
        if (*filedata != '#')
        {
            if (*filedata ==  ',')
            {
                rc = true;
            }
            else
            {
                for(i = 0, ptr= filedata;*ptr != '=';ptr++,i++)
                {
                    tag[i] = *ptr;
                }
                ptr ++;

                if (*ptr == ' ')
                {
                    ptr++;
                }
                value = ptr;
                /* Check what the tag is */
                rc2 = populateData(tag,value);
                config_total += rc2;
            }
        }
        else
        {
            printf("Comment is skipped.\n");
        }

    }
    
    
    if (config_total == 4)
    {
        rc =0;
        fprintf(stderr,"Config Items found...\n");
        goto exit_conf_check;
    }
    else 
    {
        rc = -1;
        fprintf(stderr,"Config Items missing.\n Plase check config file.[%d]\n",rc2);
        goto exit_conf_check;
    }


exit_conf_check:
        return rc;
}


/*****************************************************************
  * Function Name : populateData
  * Arguments     : in - char *, char *
  * The first Arg is the TAG that you are interested in.
  * The second is the VALUE associated with the TAG.
  * Returns : int
  ****************************************************************/

int
populateData (char *tag, char *value)
{
    int rc = 0;
    
    if (strncmp(tag,"MYSQLHost",8) == false)
    {
        data.database_info[host] = value;
        fprintf(stderr,"Host found.\n");
        rc = true;
        goto exit_point;
    }
    if (strncmp(tag,"MYSQLUser",9) == false)
    {
        data.database_info[user] = value;
        fprintf(stderr,"User found.\n");
        rc = true;
        goto exit_point;
    }
    if (strncmp(tag,"MYSQLPasswd",10) == false)
    {
        data.database_info[passwd] = value;
        fprintf(stderr,"Password found.\n");
        rc =true;

        goto exit_point;
    }
    if (strncmp(tag,"PORT",4) == false)
    {
        data.port = atoi(value);
        fprintf(stderr,"Port number.\n");
        rc = true;
        goto exit_point;
    }
exit_point :
    return rc;
}
