/********************************************************************
  * File Name   : Main.c
  * Function    : This file contains the setup for IRCD process.
  * History     : created 3rd July 2002. jcorcora
**********************************************************************/

/* HEADERS */
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include "crazyirc.h"

/* Function Prototypes */

/* Global information */
trnx_holder data;



/* Main Function */
int main(int argc, char *argv[]) {
    
    int port;
    int rc = 0;
    
    if (argc !=2) {
        fprintf(stderr,"Usage %s <config_file>.\n", argv[0]);
        rc = -1;
        goto exit_point;
    }
    memset(&data,0,sizeof(data)); 
    rc = get_config_info(argv[1]);
    if (rc == -1)
    {
        exit(rc);
    }
    fprintf(stderr,"Checking PID File.\n"); 
    rc = check_pid_file();
    
    if (rc != false)
    {
       goto exit_point;
    }
    
    create_pid_file();
    connect_2_database();
    printf("CrazyIRCD-[%s] starting up on port [%d]...\n", VERSION, data.port);

    connect_and_wait(data.port);    
    
exit_point:
    return rc;
}
